' MaldMGS.BAS written by Mark Scott January 1995
' (c) M G Scott 1995. This program may be freely copied but not
' sold or altered. To register, please send a postcard with interesting
' stamps on it (for my children), giving your name and address, to:
' Mark Scott  112 Green Lane, Horwich, Bolton BL6 7RL, United Kingdom.
' E-mail correspondence to Compuserve 72773,2662 or Internet
' MGS1@SEH1.ACS.BOLTON.AC.UK
'
DECLARE SUB message (mess$)
DECLARE FUNCTION xpixel% (xvalue)
DECLARE FUNCTION ypixel% (yvalue)
DECLARE SUB colourcheck ()
DECLARE SUB mandel (fb$)
DECLARE SUB mandelpoint (px!, py!)
DECLARE SUB newbox (fb$)
DECLARE SUB showbox (boxxl, boxxu, boxyl, boxyu, boxxl2, boxxu2, boxyl2, boxyu2)
REM Main PROGRAM
COMMON SHARED xmax!, ymax!, xl, yl, xu, yu
COMMON SHARED nxl, nyl, nxu, nyu
COMMON SHARED pgup!, pgdn!, up!, down!, left!, right!, enter!
COMMON SHARED ncrit%, stepsize%, sizecrit, ext!
ext! = 10 ' how many dots on either side of the four corner points
DIM SHARED savedpixels(ext! * 8) AS INTEGER ' For the moving box
' Key codes used to control the box
pgup! = 73: pgdn! = 81: left! = 75: right! = 77: up! = 72: down! = 80
enter! = 13
SCREEN 12
' Extent of the real space, pixels in the screen mode.
xmax! = 640
ymax! = 480
CLS 0
' CALL colourcheck  (if necessary, to check the coulours work
' starting values x and y, upper and lower, define logical space
xl = -2.2: xu = 1.5
yl = -1.7: yu = 1.7
' n values of the samething follow, n stands for NEW. Used for moving
' the box to select new logical space extent.

nxl = xl: nyl = yl: nxu = xu: nyu = yu

' stepsize% governs the coarseness (and speed) of the plot very strongly.
' A high value like 10 gives a 10 pixel wide (very coarse) plot. A value
' of 1 calculates each pixel separately, looks fantastic, and takes ages.

stepsize% = 12: fb$ = "F"  ' For first rough plot

' ncrit% governs how many times to iterate the calculation for each
' Mandelbrot point. Higher values take longer, but give better results. Low
' Values might miss real features. If the modulus of Z^2 goes above sizecrit
' the calculation is assumed to be diverging and the point is not in the set.

ncrit% = 80    ' Critical parameter for accuracy of calculation
sizecrit = 4  ' Another key parameter for the calculation
DO
  CALL mandel(fb$)   ' Plot the mandelbrot set
  CALL newbox(fb$)   ' allow user to choose new region
  CALL message(" ")  ' clear message line
  ' Get user input for the next plot
  LOCATE 1, 1
  INPUT "Enter F for full screen, B for box only, E to End:"; fb$
  fb$ = UCASE$(LEFT$(fb$, 1))
  IF fb$ <> "E" THEN
    LOCATE 1, 1
    INPUT "Step size (10 is rough, 1 is accurate but VERY slow, 0 to end)"; stepsize%
    CALL message(" ")
  END IF
LOOP UNTIL stepsize% <= 0 OR fb$ = "E"

END ' That's the end of the main program.

SUB colourcheck
' Test colours only needed for development / debugging
STATIC col%, x
col% = 0
FOR x = 0 TO 600 STEP 30
  LINE (x, 100)-(x + 15, 200), col%, BF
  col% = col% + 1
NEXT
END SUB

SUB mandel (fb$)
' Plot the Mandelbrot set
' fb$ is F for a full screen plot, B to plot the selected box only.
STATIC pxl!, pyl!, pxu!, pyu!
' ncrit% and sizecrit affect the accuracy and time taken
IF fb$ = "F" THEN
  pxl! = 0: pyl! = 20: pxu! = xmax!: pyu! = ymax!
  CLS 0 ' Clear the screen if a full screen plot is required
  CALL message("A full screen Mandelbrot set is being drawn. Please wait ...")
  ' Now update the global variables defining logical space
  ' if fb$="F" for full screen, otherwise leave as is.
  xl = nxl: yl = nyl: xu = nxu: yu = nyu
ELSE
  pxl! = xpixel%(nxl)
  pyl! = ypixel%(nyl)
  pxu! = xpixel%(nxu)
  pyu! = ypixel%(nyu)
  CALL message("A partial Mandelbrot set is being drawn. Please wait ...")
  ' Blank out the box
  LINE (pxl!, pyl!)-(pxu!, pyu!), 0, BF
END IF
' These are the loops that do the work. Scan the screen at the requested
' resolution and perform the Maldenbrot calculation.
FOR px! = pxl! TO pxu! STEP stepsize%
  FOR py! = pyl! TO pyu! STEP stepsize%
    CALL mandelpoint(px!, py!)
  NEXT
NEXT
' Wake the user up
BEEP: BEEP: BEEP
END SUB

SUB mandelpoint (px!, py!)
STATIC Cx, Cy, Zx, Zy, sizesq, count%, zx2, zy2, Zxnew, Zynew
' This is the "Engine" that decides if a point is in the set or not.
' All of the rest of the program is just setting up and presentation!
' The rule is amazingly simple: Take a (complex) number, keep squaring
' it and adding the original number. If the result heads off to
' a large-ish value, the point is not in the set.
' Px! and Py! are pixel co-ordinates, so determine logical ones.
Cx = px! / xmax * (xu - xl) + xl
Cy = py! / ymax * (yu - yl) + yl
Zx = 0: Zy = 0: sizesq = 1: count% = 0
DO WHILE (count% <= ncrit%) AND (sizesq < sizecrit)
      ' Z <- Z*Z + C is repeatedly applied, but monitoring also ...
      zx2 = Zx * Zx: zy2 = Zy * Zy
      Zxnew = (zx2 - zy2): Zynew = 2 * Zx * Zy
      Zx = Zxnew + Cx: Zy = Zynew + Cy
      sizesq = (Zx * Zx + Zy * Zy)
      count% = count% + 1
LOOP
IF count% >= ncrit% THEN count% = 0    ' Point is not in the set
IF stepsize% = 1 THEN
      ' High resolution plot - one pixel at a time.
      PSET (px!, py!), count% MOD 16
ELSE
      ' lower resolution plot, rectangles of side stepsize%
      LINE (px!, py!)-(px! + stepsize% - 1, py! + stepsize% - 1), count% MOD 16, BF
END IF

END SUB

SUB message (mess$)
' Put a message on line 1
LOCATE 1, 1
PRINT STRING$(80, " ")
LOCATE 1, 1
PRINT mess$
END SUB

SUB newbox (fb$)
' This, and showbox, have the job of allowing the user to move a box
' around the screen, or to shrink or grow it. The result gives the
' desired coordinates of the next plot.
STATIC char$, pixx, pixy, jump!
jump! = 2 ' How many pixels movement per key press
' If full screen selected, start with a small box near middle of the screen
' otherwise, leave previous values
IF fb$ = "F" THEN
  nxl = (xl + xu) / 2: nxu = nxl + (xu - nxl) / 8
  nyl = (yl + yu) / 2: nyu = nyl + (yu - nyl) / 8
END IF
' On first pass, new and old boxes are the same
nxl2 = nxl: nxu2 = nxu: nyl2 = nyl: nyu2 = nyu
CALL showbox(nxl, nxu, nyl, nyu, nxl2, nxu2, nyl2, nyu2)
' Find what one pixel is worth for x and y axes
pixx = (xu - xl) / xmax!: pixy = (yu - yl) / ymax!
CALL message("Cursors=Move Box  PgUp=Grow  PgDn=Shrink  Enter=Done")
DO
  DO
     char$ = INKEY$ ' Note keys are extended so inkey$ is two bytes
  LOOP UNTIL char$ <> ""
  REM PRINT "Got ", RIGHT$(char$, 1), ASC(RIGHT$(char$, 1))

  ' Code below has bits for each of the allowed key presses.
  SELECT CASE RIGHT$(char$, 1)

  CASE CHR$(enter!)
  BEEP
  CASE CHR$(pgup!)
  ' Grow the box, but don't let it get too large
  IF xpixel%(nxu) - xpixel%(nxl) < 2 / 3 * xmax! THEN
    nxl2 = nxl - jump! * pixx: nxu2 = nxu + jump! * pixx
    nyl2 = nyl - jump! * pixy: nyu2 = nyu + jump! * pixy
  ELSE
    BEEP
  END IF

  CASE CHR$(pgdn!)
  'shrink the box, but don't let it get too small
  IF xpixel%(nxu) - xpixel%(nxl) >= (4 * ext!) THEN
    nxl2 = nxl + jump! * pixx: nxu2 = nxu - jump! * pixx
    nyl2 = nyl + jump! * pixy: nyu2 = nyu - jump! * pixy
  ELSE
    BEEP
  END IF

  CASE CHR$(right!)
  nxl2 = nxl + jump! * pixx: nxu2 = nxu + jump! * pixx

  CASE CHR$(left!)
  nxl2 = nxl - jump! * pixx: nxu2 = nxu - jump! * pixx

  CASE CHR$(down!)
  nyl2 = nyl + jump! * pixy: nyu2 = nyu + jump! * pixy

  CASE CHR$(up!)
  nyl2 = nyl - jump! * pixy: nyu2 = nyu - jump! * pixy

  END SELECT

  ' Don't call showbox if no change in coordinates
  IF (nxl <> nxl2 AND nxu2 <> nxu) OR (nyl <> nyl2 AND nyu <> nyu2) THEN
     CALL showbox(nxl, nxu, nyl, nyu, nxl2, nxu2, nyl2, nyu2)
  END IF
  ' New box now becomes the old box
  nxl = nxl2: nxu = nxu2
  nyl = nyl2: nyu = nyu2
LOOP UNTIL RIGHT$(char$, 1) = CHR$(enter!)
END SUB

SUB showbox (boxxl, boxxu, boxyl, boxyu, boxxl2, boxxu2, boxyl2, boxyu2)
STATIC pxl!, pxu!, pyl!, pyu!, pxl2!, pxu2!, pyl2!, pyu2!, i!, c%
STATIC firstpass, cs%
' This draws the actual box, but must handle the overwritten pixels, and
' also make sure the box is visible no matter how wild the colours under
' it are.
cs% = 3 ' Colour shift, so the new box stands out from the underlying colour
' See if this is the first pass
firstpass = (boxxl = boxxl2 AND boxxu = boxxu2)
firstpass = firstpass AND (boxyl = boxyl2 AND boxyu = boxyu2)
' First two pairs are old box, second two are new box
' On the first pass, old box and new box are the same.
'
' Calculate pixel positions of the old box
pxl! = xpixel%(boxxl)
pxu! = xpixel%(boxxu)
pyl! = ypixel%(boxyl)
pyu! = ypixel%(boxyu)
' calculate pixel positions of the new box
pxl2! = xpixel%(boxxl2)
pxu2! = xpixel%(boxxu2)
pyl2! = ypixel%(boxyl2)
pyu2! = ypixel%(boxyu2)
' On first pass (old and new boxes are the same) store all pixels that
' will be affected by the new box in an array, then draw the box.
' On subsequent passes (old and new boxes differ):
' 1. Restore the pixels of the old box from the array.
' 2. Store all pixels that will be affected by the new box in the array.
' 3. Draw the new box.
c% = 1' Counter for array savedpixels
IF NOT firstpass THEN
  FOR i! = 1 TO ext!
    PSET (pxl! + i!, pyl!), savedpixels(c%): c% = c% + 1
    PSET (pxl!, pyl! + i!), savedpixels(c%): c% = c% + 1
    PSET (pxl! + i!, pyu!), savedpixels(c%): c% = c% + 1
    PSET (pxl!, pyu! - i!), savedpixels(c%): c% = c% + 1
    PSET (pxu! - i!, pyl!), savedpixels(c%): c% = c% + 1
    PSET (pxu!, pyl! + i!), savedpixels(c%): c% = c% + 1
    PSET (pxu! - i!, pyu!), savedpixels(c%): c% = c% + 1
    PSET (pxu!, pyu! - i!), savedpixels(c%): c% = c% + 1
  NEXT i!
  c% = 1
END IF
' Draw the new box, saving the content of each pixel before overwriting
' and using a colour that will contrast well.
FOR i! = 1 TO ext!
  savedpixels(c%) = POINT(pxl2! + i!, pyl2!)
  PSET (pxl2! + i!, pyl2!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxl2!, pyl2! + i!)
  PSET (pxl2!, pyl2! + i!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxl2! + i!, pyu2!)
  PSET (pxl2! + i!, pyu2!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxl2!, pyu2! - i!)
  PSET (pxl2!, pyu2! - i!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxu2! - i!, pyl2!)
  PSET (pxu2! - i!, pyl2!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxu2!, pyl2! + i!)
  PSET (pxu2!, pyl2! + i!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxu2! - i!, pyu2!)
  PSET (pxu2! - i!, pyu2!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
  savedpixels(c%) = POINT(pxu2!, pyu2! - i!)
  PSET (pxu2!, pyu2! - i!), (savedpixels(c%) + cs%) MOD 16
  c% = c% + 1
NEXT i!
END SUB

FUNCTION xpixel% (xvalue)
' Returns the pixel space coordinate of logical coordinate xvalue
xpixel% = (xvalue - xl) / (xu - xl) * xmax!
END FUNCTION

FUNCTION ypixel% (yvalue)
' Returns the pixel space coordinate of logical coordinate yvalue
ypixel% = (yvalue - yl) / (yu - yl) * ymax!
END FUNCTION

